unit Unit1;

{$mode objfpc}{$H+}

interface

uses
Classes, SysUtils, DateUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
ExtCtrls, Menus, ComCtrls, Grids, PrintersDlgs, Printers, ExtDlgs, Unit2, Unit3;

type
  TRegeldaten = Record
    Kalender : Array [1..12,1..31] of Boolean;
    end;

  { TForm1 }

  TForm1 = class(TForm)
    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    OpenDialog1: TOpenDialog;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    SaveDialog1: TSaveDialog;
    SavePictureDialog1: TSavePictureDialog;
    StringGrid1: TStringGrid;
    TempStr1, TempStr2: TStringlist;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem12: TMenuItem;
    Procedure SetzRegel(Kalender: TKalender); Overload;
    Procedure SetzRegel; Overload;
    procedure DrawGrid1Click(Sender: TObject);
    procedure DrawGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DrawGrid1SelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
    procedure FormShow(Sender: TObject);
    procedure MenuItem16Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
  private
    { private declarations }
    _Free: Boolean;
    Monat: Array[1..12] of String;
    Run: Boolean;
public
    { public declarations }
    Regeldaten: TRegeldaten;
    GridSelArr : Array [1..31,1..12] of Boolean;
    Schalt: Boolean;
    status: array[0..4, 0..4] of integer;
end;

//{$IFDEV linux}
function StrtoBin(Value: String):String; External 'lib/Codelib.so';
//{$ENDIF}
{{$IFDEV WINDOWS}
Procedure StrtoBin(Value: String):String; External 'Lib\Codelib.dll';
{$ENDIF}}

var
   Form1: TForm1;
//   D, M: Byte;

implementation

{ TForm1 }

Procedure Eintrag;
begin
     with Form2 do
          Begin
          Visible:= DayTrue;
          end;
end;

Procedure TForm1.SetzRegel(Kalender: TKalender); Overload;
begin
     Form1.Caption:=  Form1.Caption + ' SEX|';
     with StringGrid1 do
          begin
          Canvas.Pen.Width:= 1;
          Canvas.Brush.Color:= Kalender.Menstruation;
          Canvas.FillRect(CellRect(Form2.Datum.Day, Form2.Datum.Month));
//          Repaint;
          end;
end;

Procedure TForm1.SetzRegel; Overload;
Const stKalender:TKalender=(Regel:clBlue;
                            Menstruation: clred;);
begin
     Form1.Caption:= 'SEX X SEX|';
     Setzregel(stKalender);
end;

procedure TForm1.DrawGrid1Click(Sender: TObject);
begin

end;

procedure TForm1.DrawGrid1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then
        begin
        Form1.Caption:= Caption + 'Mouse|';
        _Free:= True;
        end;
end;

procedure TForm1.DrawGrid1SelectCell(Sender: TObject; aCol, aRow: Integer;
  var CanSelect: Boolean);
begin
     if run then Run:= False;
     if _Free then
        begin
        Caption:= Caption + 'Select|' + IntToSTr(aCol) + '.' + IntToStr(aRow);
        if Form2.DateExist(aCol, aRow) then
           begin
           Form2.Datum.Day:= aCol;
           Form2.Datum.Month:= aRow;
           Eintrag;
          end;
        _free:= False;
        end;
end;

{procedure TForm1.DrawGrid1Click(Sender: TObject);
begin
     Form1.Caption:= Caption + 'Click|';
end;}

procedure TForm1.FormShow(Sender: TObject);
Var Temp: Byte;
begin
     TempStr1.Create;
     TempStr2.Create;
     Schalt:= IsLeapYear(YearOf(Date));
     Monat[1]:= 'Januar';
     Monat[2]:= 'Februar';
     Monat[3]:= 'März';
     Monat[4]:= 'April';
     Monat[5]:= 'Maik';
     Monat[6]:= 'Juni';
     Monat[7]:= 'Juli';
     Monat[8]:= 'August';
     Monat[9]:= 'September';
     Monat[10]:= 'Oktober';
     Monat[11]:= 'November';
     Monat[12]:= 'Dezember';
     Run:= True;
     for temp:= 1 to 12 do
         StringGrid1.Cells[0, Temp]:= Monat[Temp];
end;

procedure TForm1.MenuItem16Click(Sender: TObject);
begin
     Form3.Show;
end;

procedure TForm1.MenuItem9Click(Sender: TObject);
begin
     if PrintDialog1.Execute then
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  sg: TStringGrid;
begin
  sg := TStringGrid(Sender);
  if (aCol = 0) or (aRow = 0) then begin
    sg.Canvas.Brush.Color := clBtnFace;
  end else begin
    case status[aCol, aRow] of
      0: sg.Canvas.Brush.Color := clBlue;
      1: sg.Canvas.Brush.Color := clRed;
      2: sg.Canvas.Brush.Color := clGreen;
      else sg.Canvas.Brush.Color := clWhite;
    end;
    sg.Canvas.FillRect(aRect);
    sg.Canvas.TextRect(aRect, aRect.Left + 2, aRect.Top + 2, sg.Cells[aCol, aRow]);
    sg.Canvas.FrameRect(aRect);
  end;
end;

initialization
  {$I unit1.lrs}

end.
