unit Unit2; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls;

type
  TDatum = Record
           Day, Month : Byte;
           end;

  TKalender = Record
              Regel, Menstruation: TColor;
              end;

  { TForm2 }
  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    TempStr: TStringList;
    TempStr2: TStringList;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    Count: Byte; // Eingabemaskenzähler für Regelschmerzen
    Datum: TDatum;
    FormTemp: TStringList;
    DayTrue: Boolean;
    Function DateExist(Day, Month: Byte):Boolean;
  end;

//Procedure SetzRegel(Kalender: TKalender); Overload;
//Procedure SetzRegel; Overload;

var
  Form2: TForm2;

implementation

Uses Unit1;

{ TForm2 }

Function TForm2.DateExist(Day, Month: Byte):Boolean;
begin
     DayTrue:= False;
     case Month of
          1, 3, 5, 7, 8, 10, 12: DayTrue:= True;
          2: case Day Of
                  1..29: begin
                         DayTrue:= True;
                         if Form1.Schalt and (Day = 29) then DayTrue:= True;
                         end;
             end;
          4, 6, 9, 11: Case Day of
                            1..30 : DayTrue:= True;
                       end;
          end;
     result:= DayTrue;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
     TempStr:= TStringList.Create;
     TempStr2:= TStringList.Create;
     FormTemp:= TStringList.Create;
     Count:= 0;
     if FileExists('Test.virus') then
        TempStr.LoadFromFile('Test.virus');
end;

procedure TForm2.CheckBox1Change(Sender: TObject);
begin
     RadioGroup1.Enabled:= CheckBox1.Checked;
     Button1.Enabled:=     CheckBox1.Checked;
end;

procedure TForm2.Button2Click(Sender: TObject);
var Max: Byte;
begin
  if Count <> 0 then
     begin
     Form2.Caption:= '';
     Memo1.Lines.Clear;
     Memo1.Visible:= False;
     Edit1.Clear;
     Edit1.Visible:= False;
     Edit2.Clear;
     Edit2.Visible:= False;
     RadioGroup1.Caption:= FormTemp[0];
     RadioGroup1.Visible:= True;
     RadioGroup1.Items.Clear;
     for Max:= 1 to 5 do
         RadioGroup1.Items.Add(FormTemp[Max]);
     RadioGroup1.Top:= StrToInt(FormTemp[6]);
     CheckBox1.Checked:= False;
     CheckBox1.Visible:=  True;
     CheckBox1Change(Sender);
     TempStr.Clear;
    FormTemp.Clear;
    end;
  TempStr2.Clear;
  Visible:= False;
end;

procedure TForm2.Button1Click(Sender: TObject);
Var Max: Byte;
    Farben: TKalender;
begin
     inc(Count);
     case Count of
          1: begin
               TempStr2.Add(IntToStr(Datum.Day) + '.' +
                            IntToStr(Datum.Month));
               TempStr2.Add(RadioGroup1.Items[RadioGroup1.ItemIndex]);
               with FormTemp do
                 begin
                 add(RadioGroup1.Caption);
                 for Max:= 1 to 5 do
                   add(RadioGroup1.Items[Max-1]);
                 add(IntToStr(RadioGroup1.Top));
                 end;
               Checkbox1.Visible:= False;
               With RadioGroup1 do
                 begin
                 Caption:= 'Regelschmerzen';
                 Items.Clear;
                 Items.Add('Keine');
                 Items.Add('Leichte');
                 Items.Add('Normal');
                 Items.Add('Stark');
                 Top:= CheckBox1.Top;
                 end;
             end;
          2: begin
               TempStr2.Add(RadioGroup1.Items[RadioGroup1.ItemIndex]);
               RadioGroup1.Visible:= False;
               Label1.Visible:= True;
               Label2.Visible:= True;
               Edit1.Visible:=  True;
               Edit2.Visible:=  True;
             end;
          3: begin
               TempStr2.Add(Edit1.Text);
               TempStr2.Add(Edit2.Text);
               Label1.Visible:= False;
               Label2.Visible:= False;
               Edit1.Visible:=  False;
               Edit2.Visible:=  False;
               Memo1.Visible:=  True;
             end;
          4: begin
             Farben.Regel:= Form1.ColorDialog1.Color;
             Farben.Menstruation:= Form1.ColorDialog2.Color;
             with Memo1 do
               for Max:= 1 to Lines.Count do
                 TempStr2.Add(lines[Max-1]);
             For Max:= 1 to TempStr2.Count do
                 TempStr.Add(TempStr2[Max-1]);
             TempStr.SaveToFile('Test.virus');
             Form1.SetzRegel;
             Form1.SetzRegel(Farben);
             Button2.Click;
          end;
     end;
end;

initialization
  {$I unit2.lrs}

end.

